﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Microsoft.SharePoint.Client;
using TestCustomList.App.Resources;

namespace TestCustomList.App
{
    public partial class MainPage : PhoneApplicationPage
    {
        private List Customlist;
        private ListItemCollection ListItemcollection;

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            Loaded += MainPage_Loaded;
            
            BuildLocalizedApplicationBar();
        }

        private void BuildLocalizedApplicationBar()
        {
            ApplicationBar = new ApplicationBar();

            ApplicationBarMenuItem appBarMenuItem = new ApplicationBarMenuItem(AppResources.AppBarButtonText);
            appBarMenuItem.Click += appBarMenuItem_Click;
            ApplicationBar.MenuItems.Add(appBarMenuItem);
        }

        void appBarMenuItem_Click(object sender, EventArgs e)
        {
            NavigationService.Navigate(new Uri("/AddItem.xaml", UriKind.Relative));
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            //Get the top level Web site
            var web = App.Context.Web;
            //Fetch the desired list by title inside the web selected above
            Customlist = web.Lists.GetByTitle("TestCustomList");
            //Create a query to load all items/fields in that list
            var camlQuery = CamlQuery.CreateAllItemsQuery();
            //Fetch the items from that list using above query
            ListItemcollection = Customlist.GetItems(camlQuery);
            //Load the web app
            App.Context.Load(web);
            //Load the collection
            App.Context.Load(ListItemcollection);
            //Execute the query NOW providing Success & Failure callbacks
            App.Context.ExecuteQueryAsync(SucceededCallback, FailedCallback);
        }

        private void FailedCallback(object sender, ClientRequestFailedEventArgs args)
        {
            MessageBox.Show("Request Failed");
        }

        private void SucceededCallback(object sender, ClientRequestSucceededEventArgs args)
        {
            //Create temp list to hold items
            var list = new List<CustomListEntity>();
            //Iterate through all the items
            foreach (var item in ListItemcollection)
            {
                //Get title and add to temp list
                list.Add(new CustomListEntity(item));
            }
            //On UI thread bind temp list to ListBox
            this.Dispatcher.BeginInvoke(() =>
            {
                DemoList.ItemsSource = list;
            });
        }
    }
}